

' VBA declare statements for NAG Fortran Library DLL Mark 29.3
' Copyright 2023, Numerical Algorithms Group Ltd, Oxford, UK.
' chapter e01

   Declare Ptrsafe Sub E01AAF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef b As double, _
    ByRef c As double, _
    ByRef n1 As long, _
    ByRef n2 As long, _
    ByRef n As long, _
    ByRef x As double _
   )


   Declare Ptrsafe Sub E01ABF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef p As double, _
    ByRef a As double, _
    ByRef g As double, _
    ByRef n1 As long, _
    ByRef n2 As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01AEF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef ip As long, _
    ByRef n As long, _
    ByRef itmin As long, _
    ByRef itmax As long, _
    ByRef a As double, _
    ByRef wrk As double, _
    ByRef lwrk As long, _
    ByRef iwrk As long, _
    ByRef liwrk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01BAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef lamda As double, _
    ByRef c As double, _
    ByRef lck As long, _
    ByRef wrk As double, _
    ByRef lwrk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01BEF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01BFF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByRef m As long, _
    ByRef px As double, _
    ByRef pf As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01BGF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByRef m As long, _
    ByRef px As double, _
    ByRef pf As double, _
    ByRef pd As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01BHF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef d As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef pint As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01CEF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef lam As double, _
    ByRef negfor As long, _
    ByRef yfor As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef comm As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01CFF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef val As double, _
    ByRef fwd As double, _
    ByRef comm As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01DAF Lib "NLW32293E_nag.dll" ( _
    ByRef mx As long, _
    ByRef my As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef px As long, _
    ByRef py As long, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByRef c As double, _
    ByRef wrk As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01EAF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef triang As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01EBF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef px As double, _
    ByRef py As double, _
    ByRef pf As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01RAF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef m As long, _
    ByRef a As double, _
    ByRef u As double, _
    ByRef iw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01RBF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef a As double, _
    ByRef u As double, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01SAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef grads As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01SBF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef triang As long, _
    ByRef grads As double, _
    ByRef px As double, _
    ByRef py As double, _
    ByRef pf As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01SGF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef nw As long, _
    ByRef nq As long, _
    ByRef iq As long, _
    ByRef liq As long, _
    ByRef rq As double, _
    ByRef lrq As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01SHF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef liq As long, _
    ByRef rq As double, _
    ByRef lrq As long, _
    ByRef n As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef qy As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01TGF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef z As double, _
    ByRef f As double, _
    ByRef nw As long, _
    ByRef nq As long, _
    ByRef iq As long, _
    ByRef liq As long, _
    ByRef rq As double, _
    ByRef lrq As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01THF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef z As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef liq As long, _
    ByRef rq As double, _
    ByRef lrq As long, _
    ByRef n As long, _
    ByRef u As double, _
    ByRef v As double, _
    ByRef w As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef qy As double, _
    ByRef qz As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01TKF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef nw As long, _
    ByRef nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01TLF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01TMF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef nw As long, _
    ByRef nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01TNF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01ZAF Lib "NLW32293E_nag.dll" ( _
    ByRef d As long, _
    ByRef narr As long, _
    ByRef uniform As long, _
    ByRef axis As double, _
    ByRef lx As long, _
    ByRef v As double, _
    ByRef point As double, _
    ByRef method As long, _
    ByRef k As long, _
    ByRef wf As double, _
    ByRef ans As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01ZMF Lib "NLW32293E_nag.dll" ( _
    ByRef d As long, _
    ByRef m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef nw As long, _
    ByRef nq As long, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E01ZNF Lib "NLW32293E_nag.dll" ( _
    ByRef d As long, _
    ByRef m As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iq As long, _
    ByRef rq As double, _
    ByRef n As long, _
    ByRef xe As double, _
    ByRef q As double, _
    ByRef qx As double, _
    ByRef ifail As long _
   )


' chapter e02

   Declare Ptrsafe Sub E02ADF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef kplus1 As long, _
    ByRef lda As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef work1 As double, _
    ByRef work2 As double, _
    ByRef a As double, _
    ByRef s As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02AEF Lib "NLW32293E_nag.dll" ( _
    ByRef nplus1 As long, _
    ByRef a As double, _
    ByRef xcap As double, _
    ByRef p As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02AFF Lib "NLW32293E_nag.dll" ( _
    ByRef nplus1 As long, _
    ByRef f As double, _
    ByRef a As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02AGF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef kplus1 As long, ByRef lda As long, _
    ByRef xmin As double, ByRef xmax As double, ByRef x As double, _
    ByRef y As double, ByRef w As double, ByRef mf As long, _
    ByRef xf As double, ByRef yf As double, ByRef lyf As long, _
    ByRef ip As long, ByRef a As double, ByRef s As double, _
    ByRef np1 As long, ByRef wrk As double, ByRef lwrk As long, _
    ByRef iwrk As long, ByRef liwrk As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02AHF Lib "NLW32293E_nag.dll" ( _
    ByRef np1 As long, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef a As double, _
    ByRef ia1 As long, _
    ByRef la As long, _
    ByRef patm1 As double, _
    ByRef adif As double, _
    ByRef iadif1 As long, _
    ByRef ladif As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02AJF Lib "NLW32293E_nag.dll" ( _
    ByRef np1 As long, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef a As double, _
    ByRef ia1 As long, _
    ByRef la As long, _
    ByRef qatm1 As double, _
    ByRef aintc As double, _
    ByRef iaint1 As long, _
    ByRef laint As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02AKF Lib "NLW32293E_nag.dll" ( _
    ByRef np1 As long, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef a As double, _
    ByRef ia1 As long, _
    ByRef la As long, _
    ByRef x As double, _
    ByRef result As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02ALF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef m As long, _
    ByRef a As double, _
    ByRef ref As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02BAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef ncap7 As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef lamda As double, _
    ByRef work1 As double, _
    ByRef work2 As double, _
    ByRef c As double, _
    ByRef ss As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02BBF Lib "NLW32293E_nag.dll" ( _
    ByRef ncap7 As long, _
    ByRef lamda As double, _
    ByRef c As double, _
    ByRef x As double, _
    ByRef s As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02BCF Lib "NLW32293E_nag.dll" ( _
    ByRef ncap7 As long, _
    ByRef lamda As double, _
    ByRef c As double, _
    ByRef x As double, _
    ByRef left As long, _
    ByRef s As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02BDF Lib "NLW32293E_nag.dll" ( _
    ByRef ncap7 As long, _
    ByRef lamda As double, _
    ByRef c As double, _
    ByRef dint As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02BEF Lib "NLW32293E_nag.dll" ( _
    ByVal start As string, ByVal startlength As long, _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef w As double, _
    ByRef s As double, _
    ByRef nest As long, _
    ByRef n As long, _
    ByRef lamda As double, _
    ByRef c As double, _
    ByRef fp As double, _
    ByRef wrk As double, _
    ByRef lwrk As long, _
    ByRef iwrk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02BFF Lib "NLW32293E_nag.dll" ( _
    ByRef start As long, _
    ByRef ncap7 As long, _
    ByRef lamda As double, _
    ByRef c As double, _
    ByRef deriv As long, _
    ByRef xord As long, _
    ByRef x As double, _
    ByRef ixloc As long, _
    ByRef nx As long, _
    ByRef s As double, _
    ByRef lds As long, _
    ByRef iwrk As long, _
    ByRef liwrk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02CAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByRef k As long, _
    ByRef l As long, ByRef x As double, ByRef y As double, _
    ByRef f As double, ByRef w As double, ByRef mtot As long, _
    ByRef a As double, ByRef na As long, ByRef xmin As double, _
    ByRef xmax As double, ByRef nux As double, ByRef inuxp1 As long, _
    ByRef nuy As double, ByRef inuyp1 As long, ByRef work As double, _
    ByRef nwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02CBF Lib "NLW32293E_nag.dll" ( _
    ByRef mfirst As long, _
    ByRef mlast As long, _
    ByRef k As long, _
    ByRef l As long, _
    ByRef x As double, _
    ByRef xmin As double, _
    ByRef xmax As double, _
    ByRef y As double, _
    ByRef ymin As double, _
    ByRef ymax As double, _
    ByRef ff As double, _
    ByRef a As double, _
    ByRef na As long, _
    ByRef work As double, _
    ByRef nwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02DAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef px As long, ByRef py As long, _
    ByRef x As double, ByRef y As double, ByRef f As double, _
    ByRef w As double, ByRef lamda As double, ByRef mu As double, _
    ByRef point As long, ByRef npoint As long, ByRef dl As double, _
    ByRef c As double, ByRef nc As long, ByRef ws As double, _
    ByRef nws As long, ByRef eps As double, ByRef sigma As double, _
    ByRef rank As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02DCF Lib "NLW32293E_nag.dll" ( _
    ByVal start As string, ByVal startlength As long, ByRef mx As long, ByRef x As double, _
    ByRef my As long, ByRef y As double, ByRef f As double, _
    ByRef s As double, ByRef nxest As long, ByRef nyest As long, _
    ByRef nx As long, ByRef lamda As double, ByRef ny As long, _
    ByRef mu As double, ByRef c As double, ByRef fp As double, _
    ByRef wrk As double, ByRef lwrk As long, ByRef iwrk As long, _
    ByRef liwrk As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02DDF Lib "NLW32293E_nag.dll" ( _
    ByVal start As string, ByVal startlength As long, ByRef m As long, ByRef x As double, _
    ByRef y As double, ByRef f As double, ByRef w As double, _
    ByRef s As double, ByRef nxest As long, ByRef nyest As long, _
    ByRef nx As long, ByRef lamda As double, ByRef ny As long, _
    ByRef mu As double, ByRef c As double, ByRef fp As double, _
    ByRef rank As long, ByRef wrk As double, ByRef lwrk As long, _
    ByRef iwrk As long, ByRef liwrk As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02DEF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef px As long, _
    ByRef py As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByRef c As double, _
    ByRef ff As double, _
    ByRef wrk As double, _
    ByRef iwrk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02DFF Lib "NLW32293E_nag.dll" ( _
    ByRef mx As long, _
    ByRef my As long, _
    ByRef px As long, _
    ByRef py As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByRef c As double, _
    ByRef ff As double, _
    ByRef wrk As double, _
    ByRef lwrk As long, _
    ByRef iwrk As long, _
    ByRef liwrk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02DHF Lib "NLW32293E_nag.dll" ( _
    ByRef mx As long, _
    ByRef my As long, _
    ByRef px As long, _
    ByRef py As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByRef c As double, _
    ByRef nux As long, _
    ByRef nuy As long, _
    ByRef z As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02GAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByRef b As double, _
    ByRef nplus2 As long, _
    ByRef toler As double, _
    ByRef x As double, _
    ByRef resid As double, _
    ByRef irank As long, _
    ByRef iter As long, _
    ByRef iwork As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E02GBF_MONIT( _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef niter As long, _
'      ByRef k As long, _
'      ByRef el1n As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E02GBF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef mpl As long, _
    ByRef e As double, _
    ByRef lde As long, _
    ByRef f As double, _
    ByRef x As double, _
    ByRef mxs As long, _
    ByVal monit As longPtr, _
    ByRef iprint As long, _
    ByRef k As long, _
    ByRef el1n As double, _
    ByRef indx As long, _
    ByRef w As double, _
    ByRef iw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02GCF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByRef sda As long, _
    ByRef lda As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef tol As double, _
    ByRef relerr As double, _
    ByRef x As double, _
    ByRef resmax As double, _
    ByRef irank As long, _
    ByRef iter As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02JDF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef f As double, _
    ByRef lsminp As long, _
    ByRef lsmaxp As long, _
    ByRef nxcels As long, _
    ByRef nycels As long, _
    ByRef lcoefs As long, _
    ByRef coefs As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02JEF Lib "NLW32293E_nag.dll" ( _
    ByRef nevalv As long, _
    ByRef xevalv As double, _
    ByRef yevalv As double, _
    ByRef coefs As double, _
    ByRef fevalv As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02JFF Lib "NLW32293E_nag.dll" ( _
    ByRef nxeval As long, _
    ByRef nyeval As long, _
    ByRef xevalm As double, _
    ByRef yevalm As double, _
    ByRef coefs As double, _
    ByRef fevalm As double, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02RAF Lib "NLW32293E_nag.dll" ( _
    ByRef ia As long, _
    ByRef ib As long, _
    ByRef c As double, _
    ByRef ic As long, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef w As double, _
    ByRef jw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02RBF Lib "NLW32293E_nag.dll" ( _
    ByRef a As double, _
    ByRef ia As long, _
    ByRef b As double, _
    ByRef ib As long, _
    ByRef x As double, _
    ByRef ans As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02ZAF Lib "NLW32293E_nag.dll" ( _
    ByRef px As long, _
    ByRef py As long, _
    ByRef lamda As double, _
    ByRef mu As double, _
    ByRef m As long, _
    ByRef x As double, _
    ByRef y As double, _
    ByRef point As long, _
    ByRef npoint As long, _
    ByRef adres As long, _
    ByRef nadres As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02ZKF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef iopts As long, _
    ByRef liopts As long, _
    ByRef opts As double, _
    ByRef lopts As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E02ZLF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As string, ByVal cvaluelength As long, _
    ByRef optype As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


' chapter e04

' skeleton code for callback function
'  Sub E04ABA_FUNCT( _
'      ByRef xc As double, _
'      ByRef fc As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04ABA Lib "NLW32293E_nag.dll" ( _
    ByVal funct As longPtr, _
    ByRef e1 As double, _
    ByRef e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef maxcal As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04ABF_FUNCT( _
'      ByRef xc As double, _
'      ByRef fc As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04ABF Lib "NLW32293E_nag.dll" ( _
    ByVal funct As longPtr, _
    ByRef e1 As double, _
    ByRef e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef maxcal As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04BBA_FUNCT( _
'      ByRef xc As double, _
'      ByRef fc As double, _
'      ByRef gc As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04BBA Lib "NLW32293E_nag.dll" ( _
    ByVal funct As longPtr, _
    ByRef e1 As double, _
    ByRef e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef maxcal As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04BBF_FUNCT( _
'      ByRef xc As double, _
'      ByRef fc As double, _
'      ByRef gc As double _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04BBF Lib "NLW32293E_nag.dll" ( _
    ByVal funct As longPtr, _
    ByRef e1 As double, _
    ByRef e2 As double, _
    ByRef a As double, _
    ByRef b As double, _
    ByRef maxcal As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04CBF_FUNCT( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04CBF_MONIT( _
'      ByRef fmin As double, _
'      ByRef fmax As double, _
'      ByVal sim_rptr As longPtr, _
'      ByRef n As long, _
'      ByRef ncall As long, _
'      ByRef serror As double, _
'      ByRef vratio As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04CBK Lib "NLW32293E_nag.dll" ( _
    ByRef fmin As double, _
    ByRef fmax As double, _
    ByVal sim_rptr As longPtr, _
    ByRef n As long, _
    ByRef ncall As long, _
    ByRef serror As double, _
    ByRef vratio As double, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04CBF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef tolf As double, _
    ByRef tolx As double, _
    ByVal funct As longPtr, _
    ByVal monit As longPtr, _
    ByRef maxcal As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub E04DGA_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04DGA Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal objfun As longPtr, _
    ByRef iter As long, _
    ByRef objf As double, _
    ByRef objgrd As double, _
    ByRef x As double, _
    ByRef iwork As long, _
    ByRef work As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04DGF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04DGF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal objfun As longPtr, _
    ByRef iter As long, _
    ByRef objf As double, _
    ByRef objgrd As double, _
    ByRef x As double, _
    ByRef iwork As long, _
    ByRef work As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04DJA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04DJF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04DKA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04DKF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


' skeleton code for callback function
'  Sub E04FCF_LSQFUN( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04FCF_LSQMON( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal s_rptr As longPtr, _
'      ByRef igrade As long, _
'      ByRef niter As long, _
'      ByRef nf As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04FDZ Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal xc_rptr As longPtr, _
    ByVal fvec_rptr As longPtr, _
    ByVal fjac_rptr As longPtr, _
    ByRef ldfjac As long, _
    ByVal s_rptr As longPtr, _
    ByRef igrade As long, _
    ByRef niter As long, _
    ByRef nf As long, _
    ByVal iw_iptr As longPtr, _
    ByRef liw As long, _
    ByVal w_rptr As longPtr, _
    ByRef lw As long _
  )

   Declare Ptrsafe Sub E04FCF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByVal lsqfun As longPtr, _
    ByVal lsqmon As longPtr, _
    ByRef iprint As long, ByRef maxcal As long, _
    ByRef eta As double, ByRef xtol As double, ByRef stepmx As double, _
    ByRef x As double, ByRef fsumsq As double, ByRef fvec As double, _
    ByRef fjac As double, ByRef ldfjac As long, ByRef s As double, _
    ByRef v As double, ByRef ldv As long, ByRef niter As long, _
    ByRef nf As long, ByRef iw As long, ByRef liw As long, _
    ByRef w As double, ByRef lw As long, ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub E04FFF_OBJFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nres As long, _
'      ByVal rx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04FFF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04FFU Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef inform As long, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

   Declare Ptrsafe Sub E04FFF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal objfun As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nres As long, _
    ByRef rx As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )




   Declare Ptrsafe Sub E04FGF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef neval As long, _
    ByRef maxeval As long, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nres As long, _
    ByRef rx As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04FYF_LSFUN1( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04FYF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal lsfun1 As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04GBF_LSQLIN( _
'      ByRef selct As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04FCV Lib "NLW32293E_nag.dll" ( _
    ByRef selct As long _
  )

   Declare Ptrsafe Sub E04HEV Lib "NLW32293E_nag.dll" ( _
    ByRef selct As long _
  )

' skeleton code for callback function
'  Sub E04GBF_LSQFUN( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04GBF_LSQMON( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal s_rptr As longPtr, _
'      ByRef igrade As long, _
'      ByRef niter As long, _
'      ByRef nf As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E04GBF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByVal lsqlin As longPtr, _
    ByVal lsqfun As longPtr, _
    ByVal lsqmon As longPtr, _
    ByRef iprint As long, _
    ByRef maxcal As long, ByRef eta As double, ByRef xtol As double, _
    ByRef stepmx As double, ByRef x As double, ByRef fsumsq As double, _
    ByRef fvec As double, ByRef fjac As double, ByRef ldfjac As long, _
    ByRef s As double, ByRef v As double, ByRef ldv As long, _
    ByRef niter As long, ByRef nf As long, ByRef iw As long, _
    ByRef liw As long, ByRef w As double, ByRef lw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04GDF_LSQFUN( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04GDF_LSQMON( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal s_rptr As longPtr, _
'      ByRef igrade As long, _
'      ByRef niter As long, _
'      ByRef nf As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E04GDF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByVal lsqfun As longPtr, _
    ByVal lsqmon As longPtr, _
    ByRef iprint As long, ByRef maxcal As long, _
    ByRef eta As double, ByRef xtol As double, ByRef stepmx As double, _
    ByRef x As double, ByRef fsumsq As double, ByRef fvec As double, _
    ByRef fjac As double, ByRef ldfjac As long, ByRef s As double, _
    ByRef v As double, ByRef ldv As long, ByRef niter As long, _
    ByRef nf As long, ByRef iw As long, ByRef liw As long, _
    ByRef w As double, ByRef lw As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04GGF_LSQFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nres As long, _
'      ByVal rx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04GGF_LSQGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nres As long, _
'      ByRef nnzrd As long, _
'      ByVal rdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04GGF_LSQHES( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nres As long, _
'      ByVal lambda_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04GGU Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nres As long, _
    ByVal lambda_rptr As longPtr, _
    ByVal hx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04GGF_LSQHPRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal y_rptr As longPtr, _
'      ByRef nres As long, _
'      ByVal hxy_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04GGV Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByVal y_rptr As longPtr, _
    ByRef nres As long, _
    ByVal hxy_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04GGF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E04GGF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal lsqfun As longPtr, _
    ByVal lsqgrd As longPtr, _
    ByVal lsqhes As longPtr, _
    ByVal lsqhprd As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nres As long, _
    ByRef rx As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04GNF_LSQFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nres As long, _
'      ByVal rx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04GNF_LSQGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nres As long, _
'      ByRef nnzrd As long, _
'      ByVal rdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04GNF_CONFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef ncnln As long, _
'      ByVal gx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04STX Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef ncnln As long, _
    ByVal gx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04GNF_CONGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzgd As long, _
'      ByVal gdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04STY Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzgd As long, _
    ByVal gdx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04GNF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E04GNF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal lsqfun As longPtr, _
    ByVal lsqgrd As longPtr, _
    ByVal confun As longPtr, _
    ByVal congrd As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nres As long, _
    ByRef rx As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04GYF_LSFUN2( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04GYF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal lsfun2 As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04GZF_LSFUN2( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04GZF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal lsfun2 As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04HCF_FUNCT( _
'      ByRef iflag As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04HCF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal funct As longPtr, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04HDF_FUNCT( _
'      ByRef iflag As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04HDF_H( _
'      ByRef iflag As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fhesl_rptr As longPtr, _
'      ByRef lh As long, _
'      ByVal fhesd_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04HDF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal funct As longPtr, _
    ByVal h As longPtr, _
    ByRef x As double, _
    ByRef g As double, _
    ByRef hesl As double, _
    ByRef lh As long, _
    ByRef hesd As double, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04HEF_LSQFUN( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04HEF_LSQHES( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal xc_rptr As longPtr, _
'      ByVal b_rptr As longPtr, _
'      ByRef lb As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04HEF_LSQMON( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal s_rptr As longPtr, _
'      ByRef igrade As long, _
'      ByRef niter As long, _
'      ByRef nf As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E04HEF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByVal lsqfun As longPtr, _
    ByVal lsqhes As longPtr, _
    ByVal lsqmon As longPtr, _
    ByRef iprint As long, _
    ByRef maxcal As long, ByRef eta As double, ByRef xtol As double, _
    ByRef stepmx As double, ByRef x As double, ByRef fsumsq As double, _
    ByRef fvec As double, ByRef fjac As double, ByRef ldfjac As long, _
    ByRef s As double, ByRef v As double, ByRef ldv As long, _
    ByRef niter As long, ByRef nf As long, ByRef iw As long, _
    ByRef liw As long, ByRef w As double, ByRef lw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04HYF_LSFUN2( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04HYF_LSHES2( _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal xc_rptr As longPtr, _
'      ByVal b_rptr As longPtr, _
'      ByRef lb As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04HYF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal lsfun2 As longPtr, _
    ByVal lshes2 As longPtr, _
    ByRef x As double, _
    ByRef fsumsq As double, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04JCF_OBJFUN( _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04JCF_MONFUN( _
'      ByRef n As long, _
'      ByRef nf As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByRef rho As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04JCP Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef nf As long, _
    ByVal x_rptr As longPtr, _
    ByRef f As double, _
    ByRef rho As double, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef inform As long _
  )

   Declare Ptrsafe Sub E04JCF Lib "NLW32293E_nag.dll" ( _
    ByVal objfun As longPtr, _
    ByRef n As long, _
    ByRef npt As long, _
    ByRef x As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef rhobeg As double, _
    ByRef rhoend As double, _
    ByVal monfun As longPtr, _
    ByRef maxcal As long, _
    ByRef f As double, _
    ByRef nf As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04JDF_OBJFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04JDV Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef fx As double, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04JDF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04JDU Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef inform As long, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

   Declare Ptrsafe Sub E04JDF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal objfun As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )




   Declare Ptrsafe Sub E04JEF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef irevcm As long, _
    ByRef neval As long, _
    ByRef maxeval As long, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04JYF_FUNCT1( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04JYF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef ibound As long, _
    ByVal funct1 As longPtr, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04KDF_FUNCT( _
'      ByRef iflag As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04KDF_MONIT( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal istate_iptr As longPtr, _
'      ByRef gpjnrm As double, _
'      ByRef cond As double, _
'      ByRef posdef As long, _
'      ByRef niter As long, _
'      ByRef nf As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04KDF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByVal funct As longPtr, _
    ByVal monit As longPtr, _
    ByRef iprint As long, ByRef maxcal As long, ByRef eta As double, _
    ByRef xtol As double, ByRef delta As double, ByRef stepmx As double, _
    ByRef ibound As long, ByRef bl As double, ByRef bu As double, _
    ByRef x As double, ByRef hesl As double, ByRef lh As long, _
    ByRef hesd As double, ByRef istate As long, ByRef f As double, _
    ByRef g As double, ByRef iw As long, ByRef liw As long, _
    ByRef w As double, ByRef lw As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04KFF_OBJFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04KFV Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef fx As double, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04KFF_OBJGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzfd As long, _
'      ByVal fdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04KFW Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzfd As long, _
    ByVal fdx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04KFF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04KFU Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef inform As long, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

   Declare Ptrsafe Sub E04KFF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal objfun As longPtr, _
    ByVal objgrd As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )




' skeleton code for callback function
'  Sub E04KYF_FUNCT2( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04KYF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef ibound As long, _
    ByVal funct2 As longPtr, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04KZF_FUNCT2( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04KZF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef ibound As long, _
    ByVal funct2 As longPtr, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04LBF_FUNCT( _
'      ByRef iflag As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04LBF_H( _
'      ByRef iflag As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fhesl_rptr As longPtr, _
'      ByRef lh As long, _
'      ByVal fhesd_rptr As longPtr, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04LBF_MONIT( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal istate_iptr As longPtr, _
'      ByRef gpjnrm As double, _
'      ByRef cond As double, _
'      ByRef posdef As long, _
'      ByRef niter As long, _
'      ByRef nf As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04LBF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByVal funct As longPtr, _
    ByVal h As longPtr, _
    ByVal monit As longPtr, _
    ByRef iprint As long, ByRef maxcal As long, _
    ByRef eta As double, ByRef xtol As double, ByRef stepmx As double, _
    ByRef ibound As long, ByRef bl As double, ByRef bu As double, _
    ByRef x As double, ByRef hesl As double, ByRef lh As long, _
    ByRef hesd As double, ByRef istate As long, ByRef f As double, _
    ByRef g As double, ByRef iw As long, ByRef liw As long, _
    ByRef w As double, ByRef lw As long, ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04LYF_FUNCT2( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByRef fc As double, _
'      ByVal gc_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04LYF_HESS2( _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal heslc_rptr As longPtr, _
'      ByRef lh As long, _
'      ByVal hesdc_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04LYF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef ibound As long, _
    ByVal funct2 As longPtr, _
    ByVal hess2 As longPtr, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef x As double, _
    ByRef f As double, _
    ByRef g As double, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04MFA Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef a As double, _
    ByRef lda As long, ByRef bl As double, ByRef bu As double, _
    ByRef cvec As double, ByRef istate As long, ByRef x As double, _
    ByRef iter As long, ByRef obj As double, ByRef ax As double, _
    ByRef clamda As double, ByRef iwork As long, ByRef liwork As long, _
    ByRef work As double, ByRef lwork As long, ByRef lwsav As long, _
    ByRef iwsav As long, ByRef rwsav As double, ByRef ifail As long _
   )

   Declare Ptrsafe Sub E04MFF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef nclin As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef cvec As double, _
    ByRef istate As long, _
    ByRef x As double, _
    ByRef iter As long, _
    ByRef obj As double, _
    ByRef ax As double, _
    ByRef clamda As double, _
    ByRef iwork As long, _
    ByRef liwork As long, _
    ByRef work As double, _
    ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04MGA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04MGF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04MHA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04MHF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


' skeleton code for callback function
'  Sub E04MTF_MONIT( _
'      ByRef handle As longPtr, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04MTU Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr, _
    ByRef inform As long _
  )

   Declare Ptrsafe Sub E04MTF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nnzu As long, _
    ByRef u As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByVal monit As longPtr, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )




   Declare Ptrsafe Sub E04MWF Lib "NLW32293E_nag.dll" ( _
    ByRef outfile As long, ByRef n As long, ByRef m As long, _
    ByRef nnzc As long, ByRef nnza As long, ByRef ncolh As long, _
    ByRef nnzh As long, ByRef lintvar As long, ByRef idxc As long, _
    ByRef c As double, ByRef iobj As long, ByRef a As double, _
    ByRef irowa As long, ByRef iccola As long, ByRef bl As double, _
    ByRef bu As double, ByVal pnames As string, ByVal pnameslength As long, ByRef nname As long, _
    ByVal crname As string, ByVal crnamelength As long, ByRef h As double, ByRef irowh As long, _
    ByRef iccolh As long, ByRef minmax As long, ByRef intvar As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04MXF Lib "NLW32293E_nag.dll" ( _
    ByRef infile As long, ByRef maxn As long, ByRef maxm As long, _
    ByRef maxnnz As long, ByRef maxncolh As long, ByRef maxnnzh As long, _
    ByRef maxlintvar As long, ByRef mpslst As long, ByRef n As long, _
    ByRef m As long, ByRef nnz As long, ByRef ncolh As long, _
    ByRef nnzh As long, ByRef lintvar As long, ByRef iobj As long, _
    ByRef a As double, ByRef irowa As long, ByRef iccola As long, _
    ByRef bl As double, ByRef bu As double, ByVal pnames As string, ByVal pnameslength As long, _
    ByRef nname As long, ByVal crname As string, ByVal crnamelength As long, ByRef h As double, _
    ByRef irowh As long, ByRef iccolh As long, ByRef minmax As long, _
    ByRef intvar As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04MZF Lib "NLW32293E_nag.dll" ( _
    ByRef infile As long, ByRef maxn As long, ByRef maxm As long, _
    ByRef maxnnz As long, ByRef xbldef As double, ByRef xbudef As double, _
    ByRef mpslst As long, ByRef n As long, ByRef m As long, _
    ByRef nnz As long, ByRef iobj As long, ByRef ncolh As long, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByVal start As string, ByVal startlength As long, _
    ByVal names As string, ByVal nameslength As long, ByRef nname As long, ByVal crname As string, ByVal crnamelength As long, _
    ByRef xs As double, ByRef istate As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NCA Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByRef nclin As long, _
    ByRef ldc As long, ByRef lda As long, ByRef c As double, _
    ByRef bl As double, ByRef bu As double, ByRef cvec As double, _
    ByRef istate As long, ByRef kx As long, ByRef x As double, _
    ByRef a As double, ByRef b As double, ByRef iter As long, _
    ByRef obj As double, ByRef clamda As double, ByRef iwork As long, _
    ByRef liwork As long, ByRef work As double, ByRef lwork As long, _
    ByRef lwsav As long, ByRef iwsav As long, ByRef rwsav As double, _
    ByRef ifail As long _
   )

   Declare Ptrsafe Sub E04NCF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByRef nclin As long, _
    ByRef ldc As long, ByRef lda As long, ByRef c As double, _
    ByRef bl As double, ByRef bu As double, ByRef cvec As double, _
    ByRef istate As long, ByRef kx As long, ByRef x As double, _
    ByRef a As double, ByRef b As double, ByRef iter As long, _
    ByRef obj As double, ByRef clamda As double, ByRef iwork As long, _
    ByRef liwork As long, ByRef work As double, ByRef lwork As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NDA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04NDF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04NEA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04NEF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


' skeleton code for callback function
'  Sub E04NFA_QPHESS( _
'      ByRef n As long, _
'      ByRef jthcol As long, _
'      ByVal h_rptr As longPtr, _
'      ByRef ldh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByVal iwsav_iptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E54NFU Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef jthcol As long, _
    ByVal h_rptr As longPtr, _
    ByRef ldh As long, _
    ByVal x_rptr As longPtr, _
    ByVal hx_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByVal iwsav_iptr As longPtr _
  )

   Declare Ptrsafe Sub E04NFA Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef a As double, _
    ByRef lda As long, ByRef bl As double, ByRef bu As double, _
    ByRef cvec As double, ByRef h As double, ByRef ldh As long, _
    ByVal qphess As longPtr, ByRef istate As long, ByRef x As double, _
    ByRef iter As long, ByRef obj As double, ByRef ax As double, _
    ByRef clamda As double, ByRef iwork As long, ByRef liwork As long, _
    ByRef work As double, ByRef lwork As long, ByRef iuser As long, _
    ByRef ruser As double, ByRef lwsav As long, ByRef iwsav As long, _
    ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04NFF_QPHESS( _
'      ByRef n As long, _
'      ByRef jthcol As long, _
'      ByVal h_rptr As longPtr, _
'      ByRef ldh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04NFU Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef jthcol As long, _
    ByVal h_rptr As longPtr, _
    ByRef ldh As long, _
    ByVal x_rptr As longPtr, _
    ByVal hx_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04NFF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef a As double, _
    ByRef lda As long, ByRef bl As double, ByRef bu As double, _
    ByRef cvec As double, ByRef h As double, ByRef ldh As long, _
    ByVal qphess As longPtr, ByRef istate As long, ByRef x As double, _
    ByRef iter As long, ByRef obj As double, ByRef ax As double, _
    ByRef clamda As double, ByRef iwork As long, ByRef liwork As long, _
    ByRef work As double, ByRef lwork As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NGA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04NGF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04NHA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04NHF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


' skeleton code for callback function
'  Sub E04NKA_QPHX( _
'      ByRef nstate As long, _
'      ByRef ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E54NKU Lib "NLW32293E_nag.dll" ( _
    ByRef nstate As long, _
    ByRef ncolh As long, _
    ByVal x_rptr As longPtr, _
    ByVal hx_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04NKA Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef m As long, ByRef nnz As long, _
    ByRef iobj As long, ByRef ncolh As long, ByVal qphx As longPtr, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByVal start As string, ByVal startlength As long, _
    ByVal names As string, ByVal nameslength As long, ByRef nname As long, ByVal crname As string, ByVal crnamelength As long, _
    ByRef ns As long, ByRef xs As double, ByRef istate As long, _
    ByRef miniz As long, ByRef minz As long, ByRef ninf As long, _
    ByRef sinf As double, ByRef obj As double, ByRef clamda As double, _
    ByRef iz As long, ByRef leniz As long, ByRef z As double, _
    ByRef lenz As long, ByRef iuser As long, ByRef ruser As double, _
    ByRef lwsav As long, ByRef iwsav As long, ByRef rwsav As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04NKF_QPHX( _
'      ByRef nstate As long, _
'      ByRef ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04NKU Lib "NLW32293E_nag.dll" ( _
    ByRef nstate As long, _
    ByRef ncolh As long, _
    ByVal x_rptr As longPtr, _
    ByVal hx_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04NKF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef m As long, ByRef nnz As long, _
    ByRef iobj As long, ByRef ncolh As long, ByVal qphx As longPtr, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByVal start As string, ByVal startlength As long, _
    ByVal names As string, ByVal nameslength As long, ByRef nname As long, ByVal crname As string, ByVal crnamelength As long, _
    ByRef ns As long, ByRef xs As double, ByRef istate As long, _
    ByRef miniz As long, ByRef minz As long, ByRef ninf As long, _
    ByRef sinf As double, ByRef obj As double, ByRef clamda As double, _
    ByRef iz As long, ByRef leniz As long, ByRef z As double, _
    ByRef lenz As long, ByRef ifail As long _
   )





   Declare Ptrsafe Sub E04NLA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04NLF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04NMA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04NMF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


   Declare Ptrsafe Sub E04NPF Lib "NLW32293E_nag.dll" ( _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef lencw As long, _
    ByRef iw As long, _
    ByRef leniw As long, _
    ByRef rw As double, _
    ByRef lenrw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04NQF_QPHX( _
'      ByRef ncolh As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal hx_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal cuser_chptr As longPtr, ByVal cuser_chptrlength As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04NSH Lib "NLW32293E_nag.dll" ( _
    ByRef ncolh As long, _
    ByVal x_rptr As longPtr, _
    ByVal hx_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal cuser_chptr As longPtr, ByVal cuser_chptrlength As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04NQF Lib "NLW32293E_nag.dll" ( _
    ByVal start As string, ByVal startlength As long, ByVal qphx As longPtr, _
    ByRef m As long, _
    ByRef n As long, ByRef ne As long, ByRef nname As long, _
    ByRef lenc As long, ByRef ncolh As long, ByRef iobj As long, _
    ByRef objadd As double, ByVal prob As string, ByVal problength As long, ByRef acol As double, _
    ByRef inda As long, ByRef loca As long, ByRef bl As double, _
    ByRef bu As double, ByRef c As double, ByVal names As string, ByVal nameslength As long, _
    ByRef helast As long, ByRef hs As long, ByRef x As double, _
    ByRef pi As double, ByRef rc As double, ByRef ns As long, _
    ByRef ninf As long, ByRef sinf As double, ByRef obj As double, _
    ByVal cw As string, ByVal cwlength As long, ByRef lencw As long, ByRef iw As long, _
    ByRef leniw As long, ByRef rw As double, ByRef lenrw As long, _
    ByVal cuser As string, ByVal cuserlength As long, ByRef iuser As long, ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NRF Lib "NLW32293E_nag.dll" ( _
    ByRef ispecs As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NSF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )




   Declare Ptrsafe Sub E04NTF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef ivalue As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NUF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef rvalue As double, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NXF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef ivalue As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04NYF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef rvalue As double, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04PCF Lib "NLW32293E_nag.dll" ( _
    ByRef itype As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef a As double, _
    ByRef lda As long, _
    ByRef b As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef tol As double, _
    ByRef x As double, _
    ByRef rnorm As double, _
    ByRef nfree As long, _
    ByRef w As double, _
    ByRef indx As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04PTF_MONIT( _
'      ByRef handle As longPtr, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04PTU Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr, _
    ByRef inform As long _
  )

   Declare Ptrsafe Sub E04PTF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nnzu As long, _
    ByRef u As double, _
    ByRef nnzuc As long, _
    ByRef uc As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByVal monit As longPtr, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )




   Declare Ptrsafe Sub E04RAF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RBF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal gtype As string, ByVal gtypelength As long, _
    ByRef lgroup As long, _
    ByRef group As long, _
    ByRef idgroup As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RCF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal ptype As string, ByVal ptypelength As long, _
    ByRef lidx As long, _
    ByRef idx As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RDF Lib "NLW32293E_nag.dll" ( _
    ByRef infile As long, _
    ByRef maxnvar As long, _
    ByRef maxnblk As long, _
    ByRef maxnnz As long, _
    ByRef filelst As long, _
    ByRef nvar As long, _
    ByRef nblk As long, _
    ByRef nnz As long, _
    ByRef cvec As double, _
    ByRef nnza As long, _
    ByRef irowa As long, _
    ByRef icola As long, _
    ByRef a As double, _
    ByRef blksizea As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04REF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef cvec As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RFF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nnzc As long, _
    ByRef idxc As long, _
    ByRef c As double, _
    ByRef nnzh As long, _
    ByRef irowh As long, _
    ByRef icolh As long, _
    ByRef h As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RGF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nnzfd As long, _
    ByRef idxfd As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RHF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RJF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nclin As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef nnzb As long, _
    ByRef irowb As long, _
    ByRef icolb As long, _
    ByRef b As double, _
    ByRef idlc As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RKF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef ncnln As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef nnzgd As long, _
    ByRef irowgd As long, _
    ByRef icolgd As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RLF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef idf As long, _
    ByRef nnzh As long, _
    ByRef irowh As long, _
    ByRef icolh As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RMF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nres As long, _
    ByRef isparse As long, _
    ByRef nnzrd As long, _
    ByRef irowrd As long, _
    ByRef icolrd As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RNF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef dima As long, _
    ByRef nnza As long, _
    ByRef nnzasum As long, _
    ByRef irowa As long, _
    ByRef icola As long, _
    ByRef a As double, _
    ByRef nblk As long, _
    ByRef blksizea As long, _
    ByRef idblk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RPF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nq As long, _
    ByRef qi As long, _
    ByRef qj As long, _
    ByRef dimq As long, _
    ByRef nnzq As long, _
    ByRef nnzqsum As long, _
    ByRef irowq As long, _
    ByRef icolq As long, _
    ByRef q As double, _
    ByRef idblk As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RSF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef s As double, _
    ByRef nnzr As long, _
    ByRef idxr As long, _
    ByRef r As double, _
    ByRef nnzq As long, _
    ByRef irowq As long, _
    ByRef icolq As long, _
    ByRef q As double, _
    ByRef idqc As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RTF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef s As double, _
    ByRef nnzr As long, _
    ByRef idxr As long, _
    ByRef r As double, _
    ByRef mf As long, _
    ByRef nnzf As long, _
    ByRef irowf As long, _
    ByRef icolf As long, _
    ByRef f As double, _
    ByRef idqc As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RWF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal cmdstr As string, ByVal cmdstrlength As long, _
    ByRef ioflag As long, _
    ByRef liarr As long, _
    ByRef iarr As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RXF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal cmdstr As string, ByVal cmdstrlength As long, _
    ByRef ioflag As long, _
    ByRef lrarr As long, _
    ByRef rarr As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RYF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nout As long, _
    ByVal cmdstr As string, ByVal cmdstrlength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04RZF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04SAF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal file As string, ByVal filelength As long, _
    ByVal ftype As string, ByVal ftypelength As long, _
    ByRef pinfo As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04SRF_OBJFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04SRV Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef fx As double, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04SRF_OBJGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzfd As long, _
'      ByVal fdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04SRW Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzfd As long, _
    ByVal fdx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04SRF_CONFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef ncnln As long, _
'      ByVal gx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04SRX Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef ncnln As long, _
    ByVal gx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04SRF_CONGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzgd As long, _
'      ByVal gdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04SRY Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzgd As long, _
    ByVal gdx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04SRF_HESS( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef ncnln As long, _
'      ByRef idf As long, _
'      ByRef sigma As double, _
'      ByVal lambda_rptr As longPtr, _
'      ByRef nnzh As long, _
'      ByVal hx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04SRZ Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef ncnln As long, _
    ByRef idf As long, _
    ByRef sigma As double, _
    ByVal lambda_rptr As longPtr, _
    ByRef nnzh As long, _
    ByVal hx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04SRF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzu As long, _
'      ByVal u_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04SRU Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzu As long, _
    ByVal u_rptr As longPtr, _
    ByRef inform As long, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

   Declare Ptrsafe Sub E04SRF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal objfun As longPtr, _
    ByVal objgrd As longPtr, _
    ByVal confun As longPtr, _
    ByVal congrd As longPtr, _
    ByVal hess As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nnzu As long, _
    ByRef u As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04STF_OBJFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04STV Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef fx As double, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04STF_OBJGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzfd As long, _
'      ByVal fdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04STW Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzfd As long, _
    ByVal fdx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04STF_CONFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef ncnln As long, _
'      ByVal gx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E04STF_CONGRD( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzgd As long, _
'      ByVal gdx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E04STF_HESS( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef ncnln As long, _
'      ByRef idf As long, _
'      ByRef sigma As double, _
'      ByVal lambda_rptr As longPtr, _
'      ByRef nnzh As long, _
'      ByVal hx_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04STZ Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef ncnln As long, _
    ByRef idf As long, _
    ByRef sigma As double, _
    ByVal lambda_rptr As longPtr, _
    ByRef nnzh As long, _
    ByVal hx_rptr As longPtr, _
    ByRef inform As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

' skeleton code for callback function
'  Sub E04STF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef nnzu As long, _
'      ByVal u_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04STU Lib "NLW32293E_nag.dll" ( _
    ByRef nvar As long, _
    ByVal x_rptr As longPtr, _
    ByRef nnzu As long, _
    ByVal u_rptr As longPtr, _
    ByRef inform As long, _
    ByVal rinfo_rptr As longPtr, _
    ByVal stats_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef cpuser As longPtr _
  )

   Declare Ptrsafe Sub E04STF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal objfun As longPtr, _
    ByVal objgrd As longPtr, _
    ByVal confun As longPtr, _
    ByVal congrd As longPtr, _
    ByVal hess As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nnzu As long, _
    ByRef u As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04SVF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef nnzu As long, _
    ByRef u As double, _
    ByRef nnzuc As long, _
    ByRef uc As double, _
    ByRef nnzua As long, _
    ByRef ua As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef inform As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04TAF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef nadd As long, _
    ByRef nvar As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04TBF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal comp As string, ByVal complength As long, _
    ByRef lidx As long, _
    ByRef idx As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04TCF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal comp As string, ByVal complength As long, _
    ByRef lidx As long, _
    ByRef idx As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04TDF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal comp As string, ByVal complength As long, _
    ByRef idx As long, _
    ByRef bli As double, _
    ByRef bui As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04TEF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef idxci As long, _
    ByRef ci As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04TJF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef idlc As long, _
    ByRef icolbj As long, _
    ByRef bij As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04UCA_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E54UDM Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncnln As long, _
    ByRef n As long, _
    ByRef ldcj As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal cjac_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub E04UCA_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04UCA Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef ncnln As long, _
    ByRef lda As long, ByRef ldcj As long, ByRef ldr As long, _
    ByRef a As double, ByRef bl As double, ByRef bu As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef iter As long, _
    ByRef istate As long, ByRef c As double, ByRef cjac As double, _
    ByRef clamda As double, ByRef objf As double, ByRef objgrd As double, _
    ByRef r As double, ByRef x As double, ByRef iwork As long, _
    ByRef liwork As long, ByRef work As double, ByRef lwork As long, _
    ByRef iuser As long, ByRef ruser As double, ByRef lwsav As long, _
    ByRef iwsav As long, ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04UCF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04UDM Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncnln As long, _
    ByRef n As long, _
    ByRef ldcj As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal cjac_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub E04UCF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04UCF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef ncnln As long, _
    ByRef lda As long, ByRef ldcj As long, ByRef ldr As long, _
    ByRef a As double, ByRef bl As double, ByRef bu As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef iter As long, _
    ByRef istate As long, ByRef c As double, ByRef cjac As double, _
    ByRef clamda As double, ByRef objf As double, ByRef objgrd As double, _
    ByRef r As double, ByRef x As double, ByRef iwork As long, _
    ByRef liwork As long, ByRef work As double, ByRef lwork As long, _
    ByRef iuser As long, ByRef ruser As double, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04UDA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04UDF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )




   Declare Ptrsafe Sub E04UEA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04UEF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


   Declare Ptrsafe Sub E04UFA Lib "NLW32293E_nag.dll" ( _
    ByRef irevcm As long, ByRef n As long, ByRef nclin As long, _
    ByRef ncnln As long, ByRef lda As long, ByRef ldcj As long, _
    ByRef ldr As long, ByRef a As double, ByRef bl As double, _
    ByRef bu As double, ByRef iter As long, ByRef istate As long, _
    ByRef c As double, ByRef cjac As double, ByRef clamda As double, _
    ByRef objf As double, ByRef objgrd As double, ByRef r As double, _
    ByRef x As double, ByRef needc As long, ByRef iwork As long, _
    ByRef liwork As long, ByRef work As double, ByRef lwork As long, _
    ByVal cwsav As string, ByVal cwsavlength As long, ByRef lwsav As long, ByRef iwsav As long, _
    ByRef rwsav As double, ByRef ifail As long _
   )

   Declare Ptrsafe Sub E04UFF Lib "NLW32293E_nag.dll" ( _
    ByRef irevcm As long, ByRef n As long, ByRef nclin As long, _
    ByRef ncnln As long, ByRef lda As long, ByRef ldcj As long, _
    ByRef ldr As long, ByRef a As double, ByRef bl As double, _
    ByRef bu As double, ByRef iter As long, ByRef istate As long, _
    ByRef c As double, ByRef cjac As double, ByRef clamda As double, _
    ByRef objf As double, ByRef objgrd As double, ByRef r As double, _
    ByRef x As double, ByRef needc As long, ByRef iwork As long, _
    ByRef liwork As long, ByRef work As double, ByRef lwork As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04UGA_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef njnln As long, _
'      ByRef nnzjac As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E54UGM Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncnln As long, _
    ByRef njnln As long, _
    ByRef nnzjac As long, _
    ByVal x_rptr As longPtr, _
    ByVal f_rptr As longPtr, _
    ByVal fjac_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub E04UGA_OBJFUN( _
'      ByRef mode As long, _
'      ByRef nonln As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E54UGN Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef nonln As long, _
    ByVal x_rptr As longPtr, _
    ByRef objf As double, _
    ByVal objgrd_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04UGA Lib "NLW32293E_nag.dll" ( _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef n As long, _
    ByRef m As long, ByRef ncnln As long, ByRef nonln As long, _
    ByRef njnln As long, ByRef iobj As long, ByRef nnz As long, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByVal start As string, ByVal startlength As long, _
    ByRef nname As long, ByVal names As string, ByVal nameslength As long, ByRef ns As long, _
    ByRef xs As double, ByRef istate As long, ByRef clamda As double, _
    ByRef miniz As long, ByRef minz As long, ByRef ninf As long, _
    ByRef sinf As double, ByRef obj As double, ByRef iz As long, _
    ByRef leniz As long, ByRef z As double, ByRef lenz As long, _
    ByRef iuser As long, ByRef ruser As double, ByRef lwsav As long, _
    ByRef iwsav As long, ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04UGF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef njnln As long, _
'      ByRef nnzjac As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04UGM Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncnln As long, _
    ByRef njnln As long, _
    ByRef nnzjac As long, _
    ByVal x_rptr As longPtr, _
    ByVal f_rptr As longPtr, _
    ByVal fjac_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub E04UGF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef nonln As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04UGN Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef nonln As long, _
    ByVal x_rptr As longPtr, _
    ByRef objf As double, _
    ByVal objgrd_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

   Declare Ptrsafe Sub E04UGF Lib "NLW32293E_nag.dll" ( _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef n As long, _
    ByRef m As long, ByRef ncnln As long, ByRef nonln As long, _
    ByRef njnln As long, ByRef iobj As long, ByRef nnz As long, _
    ByRef a As double, ByRef ha As long, ByRef ka As long, _
    ByRef bl As double, ByRef bu As double, ByVal start As string, ByVal startlength As long, _
    ByRef nname As long, ByVal names As string, ByVal nameslength As long, ByRef ns As long, _
    ByRef xs As double, ByRef istate As long, ByRef clamda As double, _
    ByRef miniz As long, ByRef minz As long, ByRef ninf As long, _
    ByRef sinf As double, ByRef obj As double, ByRef iz As long, _
    ByRef leniz As long, ByRef z As double, ByRef lenz As long, _
    ByRef iuser As long, ByRef ruser As double, ByRef ifail As long _
   )






   Declare Ptrsafe Sub E04UHA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04UHF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04UJA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04UJF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


   Declare Ptrsafe Sub E04UQA Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04UQF Lib "NLW32293E_nag.dll" ( _
    ByRef ioptns As long, _
    ByRef inform As long _
   )


   Declare Ptrsafe Sub E04URA Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long, _
    ByRef lwsav As long, _
    ByRef iwsav As long, _
    ByRef rwsav As double, _
    ByRef inform As long _
   )

   Declare Ptrsafe Sub E04URF Lib "NLW32293E_nag.dll" ( _
    ByVal str As string, ByVal strlength As long _
   )


' skeleton code for callback function
'  Sub E04USA_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E04USA_OBJFUN( _
'      ByRef mode As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByRef ldfj As long, _
'      ByRef needfi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04USA Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByRef nclin As long, _
    ByRef ncnln As long, ByRef lda As long, ByRef ldcj As long, _
    ByRef ldfj As long, ByRef ldr As long, ByRef a As double, _
    ByRef bl As double, ByRef bu As double, ByRef y As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef iter As long, _
    ByRef istate As long, ByRef c As double, ByRef cjac As double, _
    ByRef f As double, ByRef fjac As double, ByRef clamda As double, _
    ByRef objf As double, ByRef r As double, ByRef x As double, _
    ByRef iwork As long, ByRef liwork As long, ByRef work As double, _
    ByRef lwork As long, ByRef iuser As long, ByRef ruser As double, _
    ByRef lwsav As long, ByRef iwsav As long, ByRef rwsav As double, _
    ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04USF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E04USF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByRef ldfj As long, _
'      ByRef needfi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04USF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByRef nclin As long, _
    ByRef ncnln As long, ByRef lda As long, ByRef ldcj As long, _
    ByRef ldfj As long, ByRef ldr As long, ByRef a As double, _
    ByRef bl As double, ByRef bu As double, ByRef y As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef iter As long, _
    ByRef istate As long, ByRef c As double, ByRef cjac As double, _
    ByRef f As double, ByRef fjac As double, ByRef clamda As double, _
    ByRef objf As double, ByRef r As double, ByRef x As double, _
    ByRef iwork As long, ByRef liwork As long, ByRef work As double, _
    ByRef lwork As long, ByRef iuser As long, ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VGF Lib "NLW32293E_nag.dll" ( _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef lencw As long, _
    ByRef iw As long, _
    ByRef leniw As long, _
    ByRef rw As double, _
    ByRef lenrw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04VHF_USRFUN( _
'      ByRef status As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef needf As long, _
'      ByRef nf As long, _
'      ByVal f_rptr As longPtr, _
'      ByRef needg As long, _
'      ByRef leng As long, _
'      ByVal g_rptr As longPtr, _
'      ByVal cuser_chptr As longPtr, ByVal cuser_chptrlength As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04VHF Lib "NLW32293E_nag.dll" ( _
    ByRef start As long, ByRef nf As long, ByRef n As long, _
    ByRef nxname As long, ByRef nfname As long, ByRef objadd As double, _
    ByRef objrow As long, ByVal prob As string, ByVal problength As long, ByVal usrfun As longPtr, _
    ByRef iafun As long, ByRef javar As long, ByRef a As double, _
    ByRef lena As long, ByRef nea As long, ByRef igfun As long, _
    ByRef jgvar As long, ByRef leng As long, ByRef neg As long, _
    ByRef xlow As double, ByRef xupp As double, ByVal xnames As string, ByVal xnameslength As long, _
    ByRef flow As double, ByRef fupp As double, ByVal fnames As string, ByVal fnameslength As long, _
    ByRef x As double, ByRef xstate As long, ByRef xmul As double, _
    ByRef f As double, ByRef fstate As long, ByRef fmul As double, _
    ByRef ns As long, ByRef ninf As long, ByRef sinf As double, _
    ByVal cw As string, ByVal cwlength As long, ByRef lencw As long, ByRef iw As long, _
    ByRef leniw As long, ByRef rw As double, ByRef lenrw As long, _
    ByVal cuser As string, ByVal cuserlength As long, ByRef iuser As long, ByRef ruser As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04VJF_USRFUN( _
'      ByRef status As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef needf As long, _
'      ByRef nf As long, _
'      ByVal f_rptr As longPtr, _
'      ByRef needg As long, _
'      ByRef leng As long, _
'      ByVal g_rptr As longPtr, _
'      ByVal cuser_chptr As longPtr, ByVal cuser_chptrlength As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04VJF Lib "NLW32293E_nag.dll" ( _
    ByRef nf As long, ByRef n As long, ByVal usrfun As longPtr, _
    ByRef iafun As long, ByRef javar As long, ByRef a As double, _
    ByRef lena As long, ByRef nea As long, ByRef igfun As long, _
    ByRef jgvar As long, ByRef leng As long, ByRef neg As long, _
    ByRef x As double, ByRef xlow As double, ByRef xupp As double, _
    ByVal cw As string, ByVal cwlength As long, ByRef lencw As long, ByRef iw As long, _
    ByRef leniw As long, ByRef rw As double, ByRef lenrw As long, _
    ByVal cuser As string, ByVal cuserlength As long, ByRef iuser As long, ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VKF Lib "NLW32293E_nag.dll" ( _
    ByRef ispecs As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VLF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VMF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef ivalue As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VNF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef rvalue As double, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VRF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef ivalue As long, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04VSF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef rvalue As double, _
    ByVal cw As string, ByVal cwlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WBF Lib "NLW32293E_nag.dll" ( _
    ByVal rname As string, ByVal rnamelength As long, _
    ByVal cwsav As string, ByVal cwsavlength As long, _
    ByRef lcwsav As long, _
    ByRef lwsav As long, _
    ByRef llwsav As long, _
    ByRef iwsav As long, _
    ByRef liwsav As long, _
    ByRef rwsav As double, _
    ByRef lrwsav As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WCF Lib "NLW32293E_nag.dll" ( _
    ByRef iw As long, _
    ByRef leniw As long, _
    ByRef rw As double, _
    ByRef lenrw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04WDF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal ccon_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04WDP Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncnln As long, _
    ByRef n As long, _
    ByRef ldcj As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal ccon_rptr As longPtr, _
    ByVal cjac_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub E04WDF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal grad_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04WDF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef ncnln As long, _
    ByRef lda As long, ByRef ldcj As long, ByRef ldh As long, _
    ByRef a As double, ByRef bl As double, ByRef bu As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef majits As long, _
    ByRef istate As long, ByRef ccon As double, ByRef cjac As double, _
    ByRef clamda As double, ByRef objf As double, ByRef grad As double, _
    ByRef h As double, ByRef x As double, ByRef iw As long, _
    ByRef leniw As long, ByRef rw As double, ByRef lenrw As long, _
    ByRef iuser As long, ByRef ruser As double, ByRef ifail As long _
   )




   Declare Ptrsafe Sub E04WEF Lib "NLW32293E_nag.dll" ( _
    ByRef ispecs As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WFF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WGF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef ivalue As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WHF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef rvalue As double, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WKF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef ivalue As long, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04WLF Lib "NLW32293E_nag.dll" ( _
    ByVal st As string, ByVal stlength As long, _
    ByRef rvalue As double, _
    ByRef iw As long, _
    ByRef rw As double, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04XAA_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04XAA Lib "NLW32293E_nag.dll" ( _
    ByRef msglvl As long, ByRef n As long, ByRef epsrf As double, _
    ByRef x As double, ByRef mode As long, ByVal objfun As longPtr, _
    ByRef ldh As long, ByRef hforw As double, ByRef objf As double, _
    ByRef objgrd As double, ByRef hcntrl As double, ByRef h As double, _
    ByRef iwarn As long, ByRef work As double, ByRef iuser As long, _
    ByRef ruser As double, ByRef info As long, ByRef lwsav As long, _
    ByRef iwsav As long, ByRef rwsav As double, ByRef ifail As long _
   )

' skeleton code for callback function
'  Sub E04XAF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04XAF Lib "NLW32293E_nag.dll" ( _
    ByRef msglvl As long, _
    ByRef n As long, _
    ByRef epsrf As double, _
    ByRef x As double, _
    ByRef mode As long, _
    ByVal objfun As longPtr, _
    ByRef ldh As long, _
    ByRef hforw As double, _
    ByRef objf As double, _
    ByRef objgrd As double, _
    ByRef hcntrl As double, _
    ByRef h As double, _
    ByRef iwarn As long, _
    ByRef work As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef info As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04YAF_LSQFUN( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04YAF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal lsqfun As longPtr, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByRef ldfjac As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E04YBF_LSQFUN( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal xc_rptr As longPtr, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal fjac_rptr As longPtr, _
'      ByRef ldfjac As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E04YBF_LSQHES( _
'      ByRef iflag As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByVal fvec_rptr As longPtr, _
'      ByVal xc_rptr As longPtr, _
'      ByVal b_rptr As longPtr, _
'      ByRef lb As long, _
'      ByVal iw_iptr As longPtr, _
'      ByRef liw As long, _
'      ByVal w_rptr As longPtr, _
'      ByRef lw As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E04YBF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, _
    ByRef n As long, _
    ByVal lsqfun As longPtr, _
    ByVal lsqhes As longPtr, _
    ByRef x As double, _
    ByRef fvec As double, _
    ByRef fjac As double, _
    ByRef ldfjac As long, _
    ByRef b As double, _
    ByRef lb As long, _
    ByRef iw As long, _
    ByRef liw As long, _
    ByRef w As double, _
    ByRef lw As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04YCF Lib "NLW32293E_nag.dll" ( _
    ByRef job As long, _
    ByRef m As long, _
    ByRef n As long, _
    ByRef fsumsq As double, _
    ByRef s As double, _
    ByRef v As double, _
    ByRef ldv As long, _
    ByRef cj As double, _
    ByRef work As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04ZMF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04ZNF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As string, ByVal cvaluelength As long, _
    ByRef optype As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E04ZPF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByRef infile As long, _
    ByRef ifail As long _
   )


' chapter e05

   Declare Ptrsafe Sub E05JAF Lib "NLW32293E_nag.dll" ( _
    ByRef n_r As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E05JBF_OBJFUN( _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef f As double, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E05JBF_MONIT( _
'      ByRef n As long, _
'      ByRef ncall As long, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal icount_iptr As longPtr, _
'      ByRef ninit As long, _
'      ByVal list_rptr As longPtr, _
'      ByVal numpts_iptr As longPtr, _
'      ByVal initpt_iptr As longPtr, _
'      ByRef nbaskt As long, _
'      ByVal xbaskt_rptr As longPtr, _
'      ByVal boxl_rptr As longPtr, _
'      ByVal boxu_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E05JBK Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByRef ncall As long, _
    ByVal xbest_rptr As longPtr, _
    ByVal icount_iptr As longPtr, _
    ByRef ninit As long, _
    ByVal list_rptr As longPtr, _
    ByVal numpts_iptr As longPtr, _
    ByVal initpt_iptr As longPtr, _
    ByRef nbaskt As long, _
    ByVal xbaskt_rptr As longPtr, _
    ByVal boxl_rptr As longPtr, _
    ByVal boxu_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef inform As long _
  )

   Declare Ptrsafe Sub E05JBF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, _
    ByVal objfun As longPtr, _
    ByRef ibound As long, _
    ByRef iinit As long, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByRef sdlist As long, _
    ByRef list As double, _
    ByRef numpts As long, _
    ByRef initpt As long, _
    ByVal monit As longPtr, _
    ByRef x As double, _
    ByRef obj As double, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JCF Lib "NLW32293E_nag.dll" ( _
    ByRef iopts As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JDF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JEF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByVal cvalue As string, ByVal cvaluelength As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JFF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ivalue As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JGF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef rvalue As double, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Function E05JHF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   ) As long


   Declare Ptrsafe Sub E05JJF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByVal cvalue As string, ByVal cvaluelength As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JKF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ivalue As long, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05JLF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef rvalue As double, _
    ByRef comm As double, _
    ByRef lcomm As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E05KBF_OBJFUN( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef fx As double, _
'      ByRef inform As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E05KBF_MONIT( _
'      ByRef nvar As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef inform As long, _
'      ByVal rinfo_rptr As longPtr, _
'      ByVal stats_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef cpuser As longPtr _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E05KBF Lib "NLW32293E_nag.dll" ( _
    ByRef handle As longPtr, _
    ByVal objfun As longPtr, _
    ByVal monit As longPtr, _
    ByRef nvar As long, _
    ByRef x As double, _
    ByRef rinfo As double, _
    ByRef stats As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef cpuser As longPtr, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E05SAF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal vecout_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E05SAF_MONMOD( _
'      ByRef ndim As long, _
'      ByRef npar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xb_rptr As longPtr, _
'      ByRef fb As double, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal fbest_rptr As longPtr, _
'      ByVal itt_iptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E05SXM Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef npar As long, _
    ByVal x_rptr As longPtr, _
    ByVal xb_rptr As longPtr, _
    ByRef fb As double, _
    ByVal xbest_rptr As longPtr, _
    ByVal fbest_rptr As longPtr, _
    ByVal itt_iptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef inform As long _
  )

   Declare Ptrsafe Sub E05SAF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef npar As long, _
    ByRef xb As double, _
    ByRef fb As double, _
    ByRef bl As double, _
    ByRef bu As double, _
    ByVal objfun As longPtr, _
    ByVal monmod As longPtr, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef iuser As long, _
    ByRef ruser As double, _
    ByRef itt As long, _
    ByRef inform As long, _
    ByRef ifail As long _
   )


' skeleton code for callback function
'  Sub E05SBF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef ndim As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal vecout_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E05SBF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncon As long, _
'      ByRef ndim As long, _
'      ByRef ldcj As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjac_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E05SZM Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncon As long, _
    ByRef ndim As long, _
    ByRef ldcj As long, _
    ByVal needc_iptr As longPtr, _
    ByVal x_rptr As longPtr, _
    ByVal c_rptr As longPtr, _
    ByVal cjac_rptr As longPtr, _
    ByRef nstate As long, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr _
  )

' skeleton code for callback function
'  Sub E05SBF_MONMOD( _
'      ByRef ndim As long, _
'      ByRef ncon As long, _
'      ByRef npar As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal xb_rptr As longPtr, _
'      ByRef fb As double, _
'      ByVal cb_rptr As longPtr, _
'      ByVal xbest_rptr As longPtr, _
'      ByVal fbest_rptr As longPtr, _
'      ByVal cbest_rptr As longPtr, _
'      ByVal itt_iptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef inform As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E05SYM Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, _
    ByRef ncon As long, _
    ByRef npar As long, _
    ByVal x_rptr As longPtr, _
    ByVal xb_rptr As longPtr, _
    ByRef fb As double, _
    ByVal cb_rptr As longPtr, _
    ByVal xbest_rptr As longPtr, _
    ByVal fbest_rptr As longPtr, _
    ByVal cbest_rptr As longPtr, _
    ByVal itt_iptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef inform As long _
  )

   Declare Ptrsafe Sub E05SBF Lib "NLW32293E_nag.dll" ( _
    ByRef ndim As long, ByRef ncon As long, ByRef npar As long, _
    ByRef xb As double, ByRef fb As double, ByRef cb As double, _
    ByRef bl As double, ByRef bu As double, ByRef xbest As double, _
    ByRef fbest As double, ByRef cbest As double, ByVal objfun As longPtr, _
    ByVal confun As longPtr, _
    ByVal monmod As longPtr, ByRef iopts As long, _
    ByRef opts As double, ByRef iuser As long, ByRef ruser As double, _
    ByRef itt As long, ByRef inform As long, ByRef ifail As long _
   )






' skeleton code for callback function
'  Sub E05UCF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcjsl As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjsl_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E05UCF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef n As long, _
'      ByVal x_rptr As longPtr, _
'      ByRef objf As double, _
'      ByVal objgrd_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E05UCF_START( _
'      ByRef npts As long, _
'      ByVal quas_rptr As longPtr, _
'      ByRef n As long, _
'      ByRef repeat As long, _
'      ByVal bl_rptr As longPtr, _
'      ByVal bu_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef mode As long _
'    )
'      ' your code here
'  End Sub

   Declare Ptrsafe Sub E05UCZ Lib "NLW32293E_nag.dll" ( _
    ByRef npts As long, _
    ByVal quas_rptr As longPtr, _
    ByRef n As long, _
    ByRef repeat As long, _
    ByVal bl_rptr As longPtr, _
    ByVal bu_rptr As longPtr, _
    ByVal iuser_iptr As longPtr, _
    ByVal ruser_rptr As longPtr, _
    ByRef mode As long _
  )

   Declare Ptrsafe Sub E05UCF Lib "NLW32293E_nag.dll" ( _
    ByRef n As long, ByRef nclin As long, ByRef ncnln As long, _
    ByRef a As double, ByRef lda As long, ByRef bl As double, _
    ByRef bu As double, ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef npts As long, ByRef x As double, ByRef ldx As long, _
    ByVal start As longPtr, _
    ByRef repeat As long, ByRef nb As long, _
    ByRef objf As double, ByRef objgrd As double, ByRef ldobjd As long, _
    ByRef iter As long, ByRef c As double, ByRef ldc As long, _
    ByRef cjac As double, ByRef ldcjac As long, ByRef sdcjac As long, _
    ByRef r As double, ByRef ldr As long, ByRef sdr As long, _
    ByRef clamda As double, ByRef ldclda As long, ByRef istate As long, _
    ByRef listat As long, ByRef iopts As long, ByRef opts As double, _
    ByRef iuser As long, ByRef ruser As double, ByRef info As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05UDM Lib "NLW32293E_nag.dll" ( _
    ByRef mode As long, _
    ByRef ncnln As long, _
    ByRef n As long, _
    ByRef ldcjsl As long, _
    ByRef needc As long, _
    ByRef x As double, _
    ByRef c As double, _
    ByRef cjsl As double, _
    ByRef nstate As long, _
    ByRef iuser As long, _
    ByRef ruser As double _
   )


' skeleton code for callback function
'  Sub E05USF_CONFUN( _
'      ByRef mode As long, _
'      ByRef ncnln As long, _
'      ByRef n As long, _
'      ByRef ldcjsl As long, _
'      ByVal needc_iptr As longPtr, _
'      ByVal x_rptr As longPtr, _
'      ByVal c_rptr As longPtr, _
'      ByVal cjsl_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub


' skeleton code for callback function
'  Sub E05USF_OBJFUN( _
'      ByRef mode As long, _
'      ByRef m As long, _
'      ByRef n As long, _
'      ByRef ldfjsl As long, _
'      ByRef needfi As long, _
'      ByVal x_rptr As longPtr, _
'      ByVal f_rptr As longPtr, _
'      ByVal fjsl_rptr As longPtr, _
'      ByRef nstate As long, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr _
'    )
'      ' your code here
'  End Sub

' skeleton code for callback function
'  Sub E05USF_START( _
'      ByRef npts As long, _
'      ByVal quas_rptr As longPtr, _
'      ByRef n As long, _
'      ByRef repeat1 As long, _
'      ByVal bl_rptr As longPtr, _
'      ByVal bu_rptr As longPtr, _
'      ByVal iuser_iptr As longPtr, _
'      ByVal ruser_rptr As longPtr, _
'      ByRef mode As long _
'    )
'      ' your code here
'  End Sub


   Declare Ptrsafe Sub E05USF Lib "NLW32293E_nag.dll" ( _
    ByRef m As long, ByRef n As long, ByRef nclin As long, _
    ByRef ncnln As long, ByRef a As double, ByRef lda As long, _
    ByRef bl As double, ByRef bu As double, ByRef y As double, _
    ByVal confun As longPtr, _
    ByVal objfun As longPtr, _
    ByRef npts As long, _
    ByRef x As double, ByRef ldx As long, ByVal start As longPtr, _
    ByRef repeat1 As long, ByRef nb As long, ByRef objf As double, _
    ByRef f As double, ByRef fjac As double, ByRef ldfjac As long, _
    ByRef sdfjac As long, ByRef iter As long, ByRef c As double, _
    ByRef ldc As long, ByRef cjac As double, ByRef ldcjac As long, _
    ByRef sdcjac As long, ByRef clamda As double, ByRef ldclda As long, _
    ByRef istate As long, ByRef listat As long, ByRef iopts As long, _
    ByRef opts As double, ByRef iuser As long, ByRef ruser As double, _
    ByRef info As long, ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05ZKF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef iopts As long, _
    ByRef liopts As long, _
    ByRef opts As double, _
    ByRef lopts As long, _
    ByRef ifail As long _
   )


   Declare Ptrsafe Sub E05ZLF Lib "NLW32293E_nag.dll" ( _
    ByVal optstr As string, ByVal optstrlength As long, _
    ByRef ivalue As long, _
    ByRef rvalue As double, _
    ByVal cvalue As string, ByVal cvaluelength As long, _
    ByRef optype As long, _
    ByRef iopts As long, _
    ByRef opts As double, _
    ByRef ifail As long _
   )


